=== Components/FixedImagePyramids/FixedShrinkingPyramid/CMakeLists.txt ===

ADD_ELXCOMPONENT( FixedShrinkingPyramid OFF
 elxFixedShrinkingPyramid.h
 elxFixedShrinkingPyramid.hxx
 elxFixedShrinkingPyramid.cxx )
