=== Components/ImageSamplers/Full/CMakeLists.txt ===

ADD_ELXCOMPONENT( FullSampler
 elxFullSampler.h
 elxFullSampler.hxx
 elxFullSampler.cxx )
