=== debian/changelog ===
elastix (5.0.1-4) unstable; urgency=medium

  * Team upload.
  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Thu, 03 Nov 2022 13:00:01 +0100

elastix (5.0.1-3) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 12 May 2022 09:40:56 +0200

elastix (5.0.1-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [22a1156] Fix setting cmake variable SOURCE_DATE_EPOCH
  * [399a85c] Restrict to architecture amd64, matching itk v5.

 -- Steve M. Robbins <smr@debian.org>  Sat, 01 Jan 2022 17:09:49 -0600

elastix (5.0.1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
    Closes: #909280, #984047
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Remove debian/.gitlab-ci.yml in favour of debian/salsa-ci.yml
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Apply multi-arch hints.
    + elastix-doc: Add Multi-Arch: foreign.
  * Remove debian/.gitlab-ci.yml in favour of debian/salsa-ci.yml
  * Build-Depends: s/libinsighttoolkit4-dev/libinsighttoolkit5-dev/
  * Build-Depends: libcharls-dev
  * Fix install
  * Enable dh_missing --fail-missing
  * Install libANNlib-5.0.so

  [ Gert Wollny ]
  * d/control: remove Gert Wollny from uploaders

 -- Andreas Tille <tille@debian.org>  Mon, 06 Dec 2021 10:47:07 +0100
